package main

import (
	"flag"
	router "mc-client-updater-server/internal/api/v1"
	"mc-client-updater-server/pkg/conf"
	"mc-client-updater-server/pkg/dao"
	"mc-client-updater-server/pkg/log"
	"strconv"
)

var (
	debug  bool
	config string
)

func init() {
	flag.BoolVar(&debug, "debug", false, "启用debug输出")
	flag.StringVar(&config, "config", "config.toml", "配置文件路径")
	flag.Parse()
}

func main() {
	log.InitLogger(debug)
	conf.InitConfig(config)
	// 初始化DB对象
	dao.DB()
	r := router.NewRouter()

	_ = r.Run(conf.Conf.Common.Host + ":" + strconv.Itoa(int(conf.Conf.Common.Port)))
}
